#include <stdio.h>
#include <math.h>
#include "event.h"
#include "color.h"
#include "gi.h"
#include "image.h"
#include "info.h"

static int z=0;
static int l_zo=0;

inline long double
ai (long double a, long double b, long double ac, long double bc)
{
  // return (3*(2*a*a*a*(a*a-b*b)-6*a*b*b*(a*a-b*b)-(a*a-b*b)+12*a*a*a*b*b))
  //                                  /(9*(a*a-b*b)*(a*a-b*b)+36*a*a*b*b);
  // 
  return (a * a + ac - b * b);
}

inline long double
bi (long double a, long double b, long double ac, long double bc)
{
 //  return  (36*a*a*b*b*b-18*a*b*b+18*a*a*b-6*a*b)
 //          /(9*(a*a-b*b)*(a*a-b*b)+36*a*a*b*b);
 //  
 return (2.0 * a * b + bc);
}

static int iter(int x,int y,rtyp *ri,etyp *event){
  int i=ri->iter;
  long double az, bz, ac, bc, ta, tb;
      az = ((long double) x - (long double) (event->width) * 0.5) * ri->big + ri->mx;
      ac = az;
      bz = ((long double) y - (long double) (event->height) * 0.5) * ri->big + ri->my;
      bc = bz;
      for(;i > 0  && (az * az + bz * bz) < MAXRAGE;--i)
	{
	  ta = ai(az,bz,ac,bc);
	  tb = bi (az, bz, ac, bc);
	  az = ta;
	  bz = tb;
	}


    return (ri->iter-i);
}

unsigned long col(int i,rtyp *ri,etyp *event,mcolor *c){
      if(i <= 0 || i >= ri->iter)
           return event->blackpixel;
  return c[(int)((float)i/(float)ri->iter*(float)MAXCOLOR )].pixel;

 }


void
full_render(rtyp *ri, etyp * event,mcolor *c){
  int x = ri->x1 /*+ ri->zo*/;
  int y = ri->y1/* + ri->zo*/;
  int i;

  while (y < ri->y2&&!(event->events && QUIT)&&!(event->events && QUIT) && !(event->events & RESIZE) && !(event->events & UPDATE))
    {
      i=iter(x,y,ri,event);
       arena (x , y , (x + ri->zo > ri->x2  ? ri->x2 : (x + ri->zo)), (y + ri->zo > ri->y2  ? ri->y2: (y + ri->zo)), col(i,ri,event,c), *event);
      x += /*2**/ri->zo + 1;
      y += (x /*- ri->zo*/) < ri->x2 ? 0 : (/*2**/ri->zo + 1);
      x = (x /*- ri->zo*/) < ri->x2 ? x : ri->x1/*+ri->zo*/;
      if (/*!(event->Buttons & (B1 | B2 | B3)) && ri->zo < 5 &&*/ (y % 20 == 0))
	{
	  get_event (event);
	  if (event->Buttons & (B1 | B2 | B3))
	    {
	      ri->zo = (ri->zt>ri->zo?ri->zt:ri->zo);
	      ri->iter = (ri->iter > ri->iterz ? ri->iterz : ri->iter);
	    }
	}
    }
}





void 
render (rtyp *ri, etyp * event,mcolor *c,int full)
{

   if((event->Buttons & (B1 | B2 | B3)) || z==0 || full==1){
     full_render(ri,event,c);
     z=ri->zo+1;
   } else {
     int x=ri->x1,y=ri->y1,dy,dx,i=0;
     while(y<ri->y2 && !(event->Buttons & (B1 | B2 | B3))&&!(event->events && QUIT) && !(event->events & RESIZE)&& !(event->events & UPDATE)){
      
        dy=0;dx=ri->zo+1;
        while(dy<=l_zo && (y+dy)<event->height){
          while(dx<=l_zo && (x+dx)< event->width){
             i=iter(x+dx,y+dy,ri,event);
         	arena (x+dx, y+dy,x+dx, y+dy, col(i,ri,event,c), *event);
             dx++;
          }
          dy++;
          dx=ri->zo+1;
        }
        dy=ri->zo+1;dx=0;
        while(dy<=l_zo && (y+dy)<event->height){
          while(dx<=ri->zo && (x+dx)< event->width){
             i=iter(x+dx,y+dy,ri,event);
         	arena (x+dx, y+dy,x+dx, y+dy, col(i,ri,event,c), *event);
             dx++;
          }
          dy++;
          dx=0;
        }


       x+=z;
       y=((x+ri->zo>ri->x2)?(y+z):(y));
       x=((x+ri->zo>ri->x2)?(ri->x1):(x));
       if(y%(z*20)==0)
       get_event (event);
     }
   }
   l_zo=ri->zo;
}

